"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Cache_holds, _Cache_config;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Cache = void 0;
const node_ts_cache_1 = require("node-ts-cache");
const node_ts_cache_storage_memory_1 = require("node-ts-cache-storage-memory");
/**
 * Cache object for data caching
 * @template Holds
 * @extends CacheContainer
 */
class Cache extends node_ts_cache_1.CacheContainer {
    constructor(holds, config) {
        super(new node_ts_cache_storage_memory_1.MemoryStorage());
        _Cache_holds.set(this, void 0);
        _Cache_config.set(this, void 0);
        __classPrivateFieldSet(this, _Cache_holds, holds, "f");
        __classPrivateFieldSet(this, _Cache_config, config, "f");
    }
    /**
     * Cache Config this is using
     */
    get config() {
        return __classPrivateFieldGet(this, _Cache_config, "f");
    }
    /**
     * Class constructor that this Cache holds
     */
    get holds() {
        return __classPrivateFieldGet(this, _Cache_holds, "f");
    }
    /**
     * Fetches an item from the cache if it exists, else null
     * @param key Key for the item
     * @returns The item or null if it wasn't found
     */
    async get(key) {
        return (await this.getItem(key)) ?? null;
    }
    /**
     * Sets an item in the cache
     * @param key Key for the item
     * @param value The item to cache
     * @param options The caching options to use
     * @returns this for method chaining
     */
    async set(key, value, options) {
        await this.setItem(key, value, options ?? this.config);
        return this;
    }
}
exports.Cache = Cache;
_Cache_holds = new WeakMap(), _Cache_config = new WeakMap();
exports.default = Cache;
//# sourceMappingURL=Cache.js.map