import { Client } from "../client/Client";
import { Cache } from "../structures/Cache";
import { DataStructure } from "../structures/Cache";
import { ICachingOptions } from "node-ts-cache";
/**
 * Manages API methods of a data model
 * @template Holds
 */
export declare class CachedManager<Holds extends DataStructure> {
    #private;
    /**
     * The client this manager is attached to
     */
    readonly client: Client;
    /**
     * @param client Client attached to the CachedManager
     * @param holds The class constructor the manager uses
     * @param cacheConfig Config for the cache to use
     */
    constructor(client: Client, holds: Holds, cacheConfig: ICachingOptions);
    /**
     * The cache of users
     */
    get cache(): Cache<Holds>;
    /**
     * The class this manager holds
     */
    get holds(): Holds;
    /**
     * Resolves an id or instance into an instance
     * @param idOrInstance Id of the instance or the instance itself
     */
    resolve(idOrInstance: string | InstanceType<Holds>): Promise<InstanceType<Holds> | null>;
    /**
     * Resolves an id or instance into an id
     * @param idOrInstance Id of the instance of the instance itself
     */
    resolveId(idOrInstance: string | InstanceType<Holds>): string | null;
}
export default CachedManager;
//# sourceMappingURL=CachedManager.d.ts.map