import { BaseFeed, PaginateConfig } from "./BaseFeed";
import { Content } from "./Content";
import type { Client } from "../client/Client";
/**
 * Represents a feed on iFunny
 * @extends BaseFeed
 */
export declare class Feed extends BaseFeed {
    /**
     * @param client Client attached to the Feed
     * @param url Url for the feed
     */
    constructor(client: Client, url: string);
    /**
     * Scrolls through content in a feed from left to right
     * @param params Params to pass into the pagination requests - Updates automatically
     * @param markAsRead Should each post be marked as read after viewing? (Default: false)
     */
    scroll(params?: PaginateConfig, markAsRead?: boolean): AsyncGenerator<Content, void, unknown>;
}
export default Feed;
//# sourceMappingURL=Feed.d.ts.map