import { type APIUserProfile } from "@ifunny/ifunny-api-types";
import { BaseUser } from "./BaseUser";
import Feed from "./Feed";
import type { Client } from "../client/Client";
/**
 * Represents a user on iFunny
 * @extends BaseUser
 */
export declare class User extends BaseUser {
    #private;
    /**
     * @param client Client instance associated with the User
     * @param payload Payload of the User
     */
    constructor(client: Client, payload: APIUserProfile);
    /**
     * Subscribe to the User
     */
    subscribe(): Promise<void>;
    /**
     * Unsubscribe from the User
     */
    unsubscribe(): Promise<void>;
    /**
     * Get the User's timeline object
     * @returns Feed
     */
    get timeline(): Feed;
}
export default User;
//# sourceMappingURL=User.d.ts.map